// gcc -Wall -Wpedantic -Wextra -std=c17 -march=haswell -O1 array_sum.c

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <x86intrin.h>

#define LENGTH 100000

int64_t* random_integer_array(unsigned n) {
    int64_t* arr = (int64_t*)malloc(n * sizeof(int64_t));
    for (unsigned i = 0; i < n; i++) {
        arr[i] = rand() % 256;
    }
    return arr;
}

int64_t array_sum_1(int64_t* arr, unsigned n) {
    int64_t total = 0;
    for (unsigned i = 0; i < n; i++) {
        total += arr[i];
    }
    return total;
}

int main() {
    //srand(time(NULL));
    int64_t* array = random_integer_array(LENGTH);
    uint64_t st, en;
    int64_t total;

    total = 0.0;
    st = __rdtsc();
    total = array_sum_1(array, LENGTH);
    en = __rdtsc();
    printf("Calculated %ld in %lu cycles %g per element.\n", total, en-st, (double)(en-st)/LENGTH);
    
    
    return 0;
}

